//// Ejercicio 6-1 ////
////---------------////
clear;
clc;
// Definición de variables del sistema Hidráulico//
A1=1;          //Área del tanque 1[m2]
A2=0.01;       //Área del tanque 2[m2]
R1=0.5e3;     //Resistencia hidráulica 1[s/m2]
R2=1e3;       //Resistencia hidráulica 2[s/m2]
k=0.1;        //Ganancia sensor de salida
Re=(R1*R2)/(R1+R2);  // Resistencia hidráulica equivalente

// Cálculo de las matrices del modelo de estados continuo//
A = [-1/(A1*Re) 1/(A1*R2);
     1/(A2*R2) -1/(A2*R2)];
B = [k/A1;0];
C = [0 0.01];
D = 0;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//------- Parte A: Modelo de estado discreto ----------
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

// Cálculo matriz de transicion de estados
s = poly(0,"s");            // Variable de Laplace
I_2 = eye(2,2);             // Matriz identidad de 2x2
sia = s*I_2-A              // sI-A
adj_sia = coffg(sia);       // Adj(sI-A)
det_sia = det(sia);         // Det(sI-A)
inv_sia = adj_sia/det_sia;  // (sI-A)^-1


// Descomposición en fracciones parciales

// Elemento 1,1
T11=pfss(inv_sia(1,1))
// Elemento 1,2
T12=pfss(inv_sia(1,2))
// Elemento 2,1
T21=pfss(inv_sia(2,1))
// Elemento 2,2
T22=pfss(inv_sia(2,2))

//-------------------------------------------------------
// Calculo elementos de Ad
//-------------------------------------------------------

Ts=1/50; //Periodo de muestreo

// -------- Elemento Ad11 --------------
P1=roots(T11(2).den);
res1=T11(2).num;
P2=roots(T11(1).den);
res2=T11(1).num;
Ad11=res1*exp(P1*Ts)+res2*exp(P2*Ts)

// -------- Elemento Ad12 --------------
P1=roots(T12(2).den);
res1=T12(2).num;
P2=roots(T12(1).den);
res2=T12(1).num;
Ad12=res1*exp(P1*Ts)+res2*exp(P2*Ts)

// -------- Elemento Ad21 --------------
P1=roots(T21(2).den);
res1=T21(2).num;
P2=roots(T21(1).den);
res2=T21(1).num;
Ad21=res1*exp(P1*Ts)+res2*exp(P2*Ts)

// -------- Elemento Ad22 --------------
P1=roots(T22(2).den);
res1=T22(2).num;
P2=roots(T22(1).den);
res2=T22(1).num;
Ad22=res1*exp(P1*Ts)+res2*exp(P2*Ts)

//-------------------------------------------------------
// Calculo elementos de Bd
//-------------------------------------------------------

TB=inv_sia*B
TB11=pfss(TB(1,1))
TB21=pfss(TB(2,1))


// -------- Elemento Bd11 --------------
P1=roots(TB11(1).den);
P2=roots(TB11(2).den);
res1=TB11(1).num;
res2=TB11(2).num;

Bd11=(res1/P1)*exp(P1*Ts)+(res2/P2)*exp(P2*Ts)-((res1/P1)+(res2/P2))

// -------- Elemento Bd21 --------------
P1=roots(TB21(1).den);
P2=roots(TB21(2).den);
res1=TB21(1).num;
res2=TB21(2).num;

Bd21=(res1/P1)*exp(P1*Ts)+(res2/P2)*exp(P2*Ts)-((res1/P1)+(res2/P2))

// El modelo discreto resulta

Adx=[Ad11 Ad12; Ad21 Ad22];
Bdx=[Bd11;Bd21];
Cdx=C;
Ddx=D;

//---------------------------------------------------------------
// Con Scilab el pasaje el modelo continuo a discreto es directo
Gp=syslin('c',A,B,C,D);
Gpd=dscr(Gp,Ts);
[Ad,Bd,Cd,Dd]=abcd(Gpd);
// Comparativa
// Matriz A discreta
Ad
Adx
// Matriz B discreta
Bd
Bdx


//---------------------------------------------------------------

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//----- Parte B: Respuesta temporal (discreto) -------
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

clear;
clc;
// Definición de variables del sistema Hidráulico//
A1=1;          //Área del tanque 1[m2]
A2=0.01;       //Área del tanque 2[m2]
R1=0.5e3;     //Resistencia hidráulica 1[s/m2]
R2=1e3;       //Resistencia hidráulica 2[s/m2]
k=0.1;        //Ganancia sensor de salida
Re=(R1*R2)/(R1+R2);  // Resistencia hidráulica equivalente

// Cálculo de las matrices del modelo de estados continuo//
A = [-1/(A1*Re) 1/(A1*R2);
     1/(A2*R2) -1/(A2*R2)];
B = [k/A1;0];
C = [0 0.01];
D = 0;

// Modelo de estado discreto
Ts=1/50;      // Periodo de muestreo
Gp=syslin('c',A,B,C,D);
Gpd=dscr(Gp,Ts);
[Ad,Bd,Cd,Dd]=abcd(Gpd);


// ---- Calculos auxiliares --------------

z = poly(0,"z");            // Variable Discreta
I_2 = eye(2,2);             // Matriz identidad de 2x2
zia = z*I_2-Ad              // zI-Ad
adj_zia = coffg(zia);       // Adj(zI-A)
det_zia = det(zia);         // Det(zI-A)
inv_zia = adj_zia/det_zia;  // (zI-A)^-1
zpk(inv_zia)

//---------------------------------------
// Respuesta temporal variables de estado
//---------------------------------------

// X(z)=z[(zI-A)^-1]x(0)+[(zI-A)^-1]Bd*U(z)

// Calculo de función transferencia
// Condiciones iniciales nulas x(0)=0
// Respuesta al escalón amplitud 0.1

Uz=(0.1*z)/(z-1);
Tz=inv_zia*Bd;
Xz=inv_zia*Bd*Uz
Xz2=Xz/z;
zpk(Xz)


// ----- Calculo de X1(z)/z ---------

Tz11=Tz(1,1)
numTZ11=coeff(Tz11.num);
denTZ11=coeff(Tz11.den);

K0x1=-numTZ11(1,1)*0.1
Z1x1=roots(Tz11.num)
P=roots(Tz11.den)
P1x1=P(1,1)
P2x1=P(2,1)
P3x1=1;

// Solución
// X1(z)/z=res1X1/(z-P1)+res2X1/(z-P2)+res3X1/(z-P3)

res=inv([1 1 1; -(P2x1+P3x1) -(P1x1+P3x1) -(P1x1+P2x1); P2x1*P3x1 P1x1*P3x1 P1x1*P2x1])*[0;K0x1;-K0x1*Z1x1]
res1X1=res(1,1)
res2X1=res(2,1)
res3X1=res(3,1)

// ----------------------------------------


// ----- Calculo de X2(z)/z ---------
Tz21=Tz(2,1)
numTZ21=coeff(Tz21.num);
denTZ21=coeff(Tz21.den);

K0x2=numTZ21(1,1)*0.1
Z1x2=roots(Tz21.num)
P=roots(Tz21.den)
P1x2=P(1,1)
P2x2=P(2,1)
P3x2=1;

// Solución
// X2(z)/z=res1X2/(z-P1)+res2X2/(z-P2)+res3X2/(z-P3)

res=inv([1 1 1; -(P2x2+P3x2) -(P1x2+P3x2) -(P1x2+P2x2); P2x2*P3x2 P1x2*P3x2 P1x2*P2x2])*[0;K0x2;-K0x2*Z1x2]
res1X2=res(1,1)
res2X2=res(2,1)
res3X2=res(3,1)


// Soluciones en el dominio del tiempo

// Modelo continuo con salida X1
Am1 = [-1/(A1*Re) 1/(A1*R2); 1/(A2*R2) -1/(A2*R2)];
Bm1 = [k/A1;0];
Cm1 = [1 0];
Dm1 = [0];
Gpm1=syslin('c',Am1,Bm1,Cm1,Dm1);


// Modelo continuo con salida X2
Am2 = [-1/(A1*Re) 1/(A1*R2); 1/(A2*R2) -1/(A2*R2)];
Bm2 = [k/A1;0];
Cm2 = [0 1];
Dm2 = [0];
Gpm2=syslin('c',Am2,Bm2,Cm2,Dm2);


figure(1)
// --- Salida discreta X1(k)---
tk=0:1:20;
t=Ts*tk;
x1k=res1X1*(P1x1)^tk+res2X1*(P2x1)^tk+res3X1;
plot2d2((Ts*tk)',x1k');
hold on
y1=csim('step',t,0.1*Gpm1);
plot(t',y1','r');

//tk=0:1:200000;
//t=Ts*tk;
//x1k=res1X1*(P1x1)^tk+res2X1*(P2x1)^tk+res3X1;
//plot2d2((Ts*tk)',x1k');


tk=0:1:200000;
t=Ts*tk;

figure(2)
// --- Salida discreta X2(k)---
x2k=res1X2*(P1x2)^tk+res2X2*(P2x2)^tk+res3X2;
plot2d2((Ts*tk)',x2k');
hold on
y2=csim('step',t,0.1*Gpm2);
plot(t',y2','r');



